require 'spec_helper'

describe Solo do
  before { configure }

  describe Solo::Customer do 
    it "Searches SOLO Customers for a name" do
      VCR.use_cassette('search_for_john') do
        results = Solo::Customer.search(:FirstName => 'John')
        results.should have_key "Customer"
      end
    end

    it "Searches errors searching for BULLSHIT" do
      VCR.use_cassette('search_for_bullshit') do
        results = Solo::Customer.search(:BULLSHIT => 'John')
        results.should have_key "ResultCode"
        results["ResultCode"].should == "100"
      end
    end

    it "Searches for customer ID via GetCustomerDataByAuthor" do
      VCR.use_cassette('search_by_valid_id') do
        customer = Solo::Customer.search_by_id('20496203')
        customer.class.should == Hash
        customer["Customer"]["CompanyName"].should == "TESTWEBSEV"
        customer["License"].size.should > 0
      end
    end

    it "Searches and returns and error with invalid customer ID" do
      VCR.use_cassette('search_by_invalid_id') do
        customer = Solo::Customer.search_by_id('40496203')
        customer.class.should == Hash
        customer["ResultCode"].should == "100"
      end
    end

    it "Creates a new customer" do
      VCR.use_cassette('create_test_customer') do
        customerid = Solo::Customer.create!(:companyName => 'Testwebsev',
                                               :firstName => 'Ron',
                                               :lastName => 'Paul')
        customerid.should > 0
      end
    end
  end
end
